Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.ss.usermodel
Interface FormulaEvaluator

All Known Implementing Classes:
  HSSFFormulaEvaluator

    public interface FormulaEvaluator

Evaluates formula cells.

For performance reasons, this class keeps a cache of all previously calculated intermediate cell values. Be sure to call `clearAllCachedResultValues()` if any workbook cells are changed between calls to evaluate~ methods on this class.

Author:
  Amol S. Deshmukh < amolweb at ya hoo dot com >, Josh Micich

Method Summary
`void` | `clearAllCachedResultValues()` Should be called whenever there are changes to input cells in the evaluated workbook.
`CellValue` | `evaluate(Cell cell)` If cell contains a formula, the formula is evaluated and returned, else the CellValue simply copies the appropriate cell value from the cell and also its cell type.
`void` | `evaluateAll()` Loops over all cells in all sheets of the associated workbook.
`int` | `evaluateFormulaCell(Cell cell)` If cell contains formula, it evaluates the formula, and saves the result of the formula.
`Cell` | `evaluateInCell(Cell cell)` If cell contains formula, it evaluates the formula, and puts the formula result back into the cell, in place of the old formula.
`void` | `notifyDeleteCell(Cell cell)` Should be called to tell the cell value cache that the specified cell has just become a formula cell, or the formula text has changed
`void` | `notifySetFormula(Cell cell)` Should be called to tell the cell value cache that the specified (value or formula) cell has changed.
`void` | `notifyUpdateCell(Cell cell)` Should be called to tell the cell value cache that the specified (value or formula) cell has changed.

Method Detail

### clearAllCachedResultValues

    void clearAllCachedResultValues()

  Should be called whenever there are changes to input cells in the evaluated workbook. Failure to call this method after changing cell values will cause incorrect behaviour of the evaluate~ methods of this class

### notifySetFormula

    void notifySetFormula(Cell cell)

  Should be called to tell the cell value cache that the specified (value or formula) cell has changed. Failure to call this method after changing cell values will cause incorrect behaviour of the evaluate~ methods of this class

### notifyDeleteCell

    void notifyDeleteCell(Cell cell)

  Should be called to tell the cell value cache that the specified cell has just become a formula cell, or the formula text has changed

### notifyUpdateCell

    void notifyUpdateCell(Cell cell)

  Should be called to tell the cell value cache that the specified (value or formula) cell has changed. Failure to call this method after changing cell values will cause incorrect behaviour of the evaluate~ methods of this class

### evaluateAll

    void evaluateAll()

  Loops over all cells in all sheets of the associated workbook. For cells that contain formulas, their formulas are evaluated, and the results are saved. These cells remain as formula cells. For cells that do not contain formulas, no changes are made. This is a helpful wrapper around looping over all cells, and calling evaluateFormulaCell on each one.

### evaluate

    CellValue evaluate(Cell cell)

  If cell contains a formula, the formula is evaluated and returned, else the CellValue simply copies the appropriate cell value from the cell and also its cell type. This method should be preferred over evaluateInCell() when the call should not modify the contents of the original cell.

  Parameters:
    `cell` -

### evaluateFormulaCell

    int evaluateFormulaCell(Cell cell)

  If cell contains formula, it evaluates the formula, and saves the result of the formula. The cell remains as a formula cell. Else if cell does not contain formula, this method leaves the cell unchanged. Note that the type of the formula result is returned, so you know what kind of value is also stored with the formula.

       int evaluatedCellType = evaluator.evaluateFormulaCell(cell);

  Be aware that your cell will hold both the formula, and the result. If you want the cell replaced with the result of the formula, use `evaluateInCell(Cell)`

  Parameters:
    `cell` - The cell to evaluate
  Returns:
    The type of the formula result (the cell's type remains as Cell.CELL_TYPE_FORMULA however)

### evaluateInCell

    Cell evaluateInCell(Cell cell)

  If cell contains formula, it evaluates the formula, and puts the formula result back into the cell, in place of the old formula. Else if cell does not contain formula, this method leaves the cell unchanged. Note that the same instance of Cell is returned to allow chained calls like:

       int evaluatedCellType = evaluator.evaluateInCell(cell).getCellType();

  Be aware that your cell value will be changed to hold the result of the formula. If you simply want the formula value computed for you, use `evaluateFormulaCell(Cell)`

  Parameters:
    `cell` -

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD